Attribute VB_Name = "modSharedCode"
Option Explicit

' Global variable to store reference to host application.
Public gobjAppInstance   As Object
Public gOneObj As Boolean
' Constants for characters surrounding ProgID.
Public Const PROG_ID_START As String = "!<"
Public Const PROG_ID_END As String = ">"

' Constants for menu item in Office application.
Public Const CBR_NAME       As String = "Add-ins"
Public Const CTL_CAPTION    As String = "&Align/Distribute"
Public Const CTL_KEY        As String = "Align"
Public Const CTL_NAME       As String = "Align"

Sub AddInErr(errX As ErrObject)
    ' Displays message box with error information.

    Dim strMsg As String
    
    strMsg = "An error occurred in the COM add-in named 'Align/Distribute'." _
        & vbCrLf & "Error #:" & errX.Number & vbCrLf & errX.Description
    MsgBox strMsg, , "Error!"
End Sub

Function CreateAddInCommandBarButton(ByVal Application As Object, _
    ByVal ConnectMode As AddInDesignerObjects.ext_ConnectMode, _
    ByVal AddInInst As Object) As Office.CommandBarButton
    
    ' This procedure assigns a reference to the Application
    ' object passed to the OnConnection event to a global
    ' object variable. It then creates a new command bar
    ' button and returns a reference to the button to the
    ' OnConnection event procedure. The advantage to
    ' putting this code in a public module is that if you
    ' have more than one add-in designer in the project, you can
    ' call this procedure from each of them rather than
    ' duplicating the code.
    
    Dim cbrMenu                     As Office.CommandBar
    Dim ctlBtnAddIn                 As Office.CommandBarButton
    
    'On Error GoTo CreateAddInCommandBarButton_Err
    On Error Resume Next
    ' Return reference to Application object and store it in public variable
    ' so that other procedures in add-in can use it.
    Set gobjAppInstance = Application
    
    ' Return reference to command bar.
    Set cbrMenu = gobjAppInstance.CommandBars.Add("Add-ins")
    CommandBars("Add-ins").Visible = True
    'If cbrMenu Is Nothing Then
    '    gobjAppInstance.CommandBars.Add CBR_NAME
    '    Set cbrMenu = gobjAppInstance.CommandBars(CBR_NAME)
    'End If
    ' Add button to call add-in from command bar, if it doesn't
    ' already exist.
    ' Constants are declared at module level.
    ' Look for button on command bar.
    'If ctlBtnAddIn Is Nothing Then
        ' Add new button.
        Dim cBob
        Set cBob = Publisher.CommandBars("Add-ins").Controls.Add(msoControlButton, "Align", "Align")
        ' Set button's Caption, Tag, Style, and OnAction properties.
        Set ctlBtnAddIn = Publisher.CommandBars.FindControl(Tag:="Align")
        With Publisher.CommandBars("Add-ins").Controls("Align")
            .Caption = "&Align/Distribute"
            .Tag = CTL_KEY
            .Style = msoButtonIconAndCaption
            ' Use AddInInst argument to return reference
            ' to this add-in.
            .OnAction = PROG_ID_START & AddInInst.ProgId _
                & PROG_ID_END
            .FaceId = 668
        End With
    'End If
    
    ' Return reference to new commandbar button.
    Set CreateAddInCommandBarButton = ctlBtnAddIn
    
CreateAddInCommandBarButton_End:
    Exit Function

CreateAddInCommandBarButton_Err:
    Select Case Err
        Case 5
            Resume Next
        Case Else
            ' Call generic error handler for add-in.
            AddInErr Err
            Resume CreateAddInCommandBarButton_End
    End Select
End Function

Function RemoveAddInCommandBarButton(ByVal _
    RemoveMode As AddInDesignerObjects.ext_DisconnectMode)

    ' This procedure removes the command bar button for
    ' the add-in if the user disconnected it.

    On Error GoTo RemoveAddInCommandBarButton_Err
    
    ' If user unloaded add-in, remove button. Otherwise, add-in is
    ' being unloaded because application is closing; in that case,
    ' leave button as is.
    If RemoveMode = ext_dm_UserClosed Then
        On Error Resume Next
        ' Delete custom command bar button.
        gobjAppInstance.CommandBars(CBR_NAME).Controls(CTL_NAME).Delete
        On Error GoTo RemoveAddInCommandBarButton_Err
    End If
    
RemoveAddInCommandBarButton_End:
    Exit Function
    
RemoveAddInCommandBarButton_Err:
    AddInErr Err
    Resume RemoveAddInCommandBarButton_End
End Function
